Index: frontends/php/include/valuemap.inc.php
===================================================================
--- frontends/php/include/valuemap.inc.php	(revision 38884)
+++ frontends/php/include/valuemap.inc.php	(working copy)
@@ -26,9 +26,9 @@
 		foreach($mappings as $map){
 			$mappingid = get_dbid("mappings","mappingid");
 
-			$result = DBexecute("insert into mappings (mappingid,valuemapid, value, newvalue)".
-				" values (".$mappingid.",".$valuemapid.",".zbx_dbstr($map["value"]).",".
-				zbx_dbstr($map["newvalue"]).")");
+			$result = DBexecute('insert into mappings (mappingid,valuemapid, value, newvalue)'.
+				' values ('.zbx_dbstr($mappingid).','.zbx_dbstr($valuemapid).','.zbx_dbstr($map["value"]).','.
+				zbx_dbstr($map["newvalue"]).')');
 
 			if(!$result)
 				return $result;
@@ -41,7 +41,7 @@
 
 		$valuemapid = get_dbid("valuemaps","valuemapid");
 
-		$result = DBexecute("insert into valuemaps (valuemapid,name) values ($valuemapid,".zbx_dbstr($name).")");
+		$result = DBexecute('insert into valuemaps (valuemapid,name) values ('.zbx_dbstr($valuemapid).','.zbx_dbstr($name).')');
 		if(!$result)
 			return $result;
 
@@ -59,7 +59,7 @@
 		if(!is_array($mappings))	return FALSE;
 
 		$result = DBexecute('UPDATE valuemaps SET name='.zbx_dbstr($name).
-			' WHERE valuemapid='.$valuemapid);
+			' WHERE valuemapid='.zbx_dbstr($valuemapid));
 
 		if(!$result)
 			return $result;
@@ -72,8 +72,8 @@
 	}
 
 	function delete_valuemap($valuemapid){
-		DBexecute('DELETE FROM mappings WHERE valuemapid='.$valuemapid);
-		DBexecute('DELETE FROM valuemaps WHERE valuemapid='.$valuemapid);
+		DBexecute('DELETE FROM mappings WHERE valuemapid='.zbx_dbstr($valuemapid));
+		DBexecute('DELETE FROM valuemaps WHERE valuemapid='.zbx_dbstr($valuemapid));
 	return TRUE;
 	}
 
@@ -85,7 +85,7 @@
 
 		$sql = 'SELECT newvalue '.
 				' FROM mappings '.
-				' WHERE valuemapid='.$valuemapid.
+				' WHERE valuemapid='.zbx_dbstr($valuemapid).
 					' AND value='.zbx_dbstr($value);
 		$result = DBselect($sql);
 		if($row = DBfetch($result)){
Index: frontends/php/api/classes/class.cgraph.php
===================================================================
--- frontends/php/api/classes/class.cgraph.php	(revision 38884)
+++ frontends/php/api/classes/class.cgraph.php	(working copy)
@@ -225,7 +225,7 @@
 
 // type
 		if(!is_null($options['type'] )){
-			$sql_parts['where'][] = 'g.type='.$options['type'];
+			$sql_parts['where'][] = 'g.type='.zbx_dbstr($options['type']);
 		}
 
 // templated
@@ -719,22 +719,22 @@
 			'graphid' => $graphid,
 			'name' => zbx_dbstr($graph['name'])
 		);
-		if(isset($graph['width'])) $values['width'] = $graph['width'];
-		if(isset($graph['height'])) $values['height'] = $graph['height'];
-		if(isset($graph['ymin_type'])) $values['ymin_type'] = $graph['ymin_type'];
-		if(isset($graph['ymax_type'])) $values['ymax_type'] = $graph['ymax_type'];
-		if(isset($graph['yaxismin'])) $values['yaxismin'] = $graph['yaxismin'];
-		if(isset($graph['yaxismax'])) $values['yaxismax'] = $graph['yaxismax'];
-		if(isset($graph['ymin_itemid'])) $values['ymin_itemid'] = $graph['ymin_itemid'];
-		if(isset($graph['ymax_itemid'])) $values['ymax_itemid'] = $graph['ymax_itemid'];
-		if(isset($graph['show_work_period'])) $values['show_work_period'] = $graph['show_work_period'];
-		if(isset($graph['show_triggers'])) $values['show_triggers'] = $graph['show_triggers'];
-		if(isset($graph['graphtype'])) $values['graphtype'] = $graph['graphtype'];
-		if(isset($graph['show_legend'])) $values['show_legend'] = $graph['show_legend'];
-		if(isset($graph['show_3d'])) $values['show_3d'] = $graph['show_3d'];
-		if(isset($graph['percent_left'])) $values['percent_left'] = $graph['percent_left'];
-		if(isset($graph['percent_right'])) $values['percent_right'] = $graph['percent_right'];
-		if(isset($graph['templateid'])) $values['templateid'] = $graph['templateid'];
+		if(isset($graph['width'])) $values['width'] = zbx_dbstr($graph['width']);
+		if(isset($graph['height'])) $values['height'] = zbx_dbstr($graph['height']);
+		if(isset($graph['ymin_type'])) $values['ymin_type'] = zbx_dbstr($graph['ymin_type']);
+		if(isset($graph['ymax_type'])) $values['ymax_type'] = zbx_dbstr($graph['ymax_type']);
+		if(isset($graph['yaxismin'])) $values['yaxismin'] = zbx_dbstr($graph['yaxismin']);
+		if(isset($graph['yaxismax'])) $values['yaxismax'] = zbx_dbstr($graph['yaxismax']);
+		if(isset($graph['ymin_itemid'])) $values['ymin_itemid'] = zbx_dbstr($graph['ymin_itemid']);
+		if(isset($graph['ymax_itemid'])) $values['ymax_itemid'] = zbx_dbstr($graph['ymax_itemid']);
+		if(isset($graph['show_work_period'])) $values['show_work_period'] = zbx_dbstr($graph['show_work_period']);
+		if(isset($graph['show_triggers'])) $values['show_triggers'] = zbx_dbstr($graph['show_triggers']);
+		if(isset($graph['graphtype'])) $values['graphtype'] = zbx_dbstr($graph['graphtype']);
+		if(isset($graph['show_legend'])) $values['show_legend'] = zbx_dbstr($graph['show_legend']);
+		if(isset($graph['show_3d'])) $values['show_3d'] = zbx_dbstr($graph['show_3d']);
+		if(isset($graph['percent_left'])) $values['percent_left'] = zbx_dbstr($graph['percent_left']);
+		if(isset($graph['percent_right'])) $values['percent_right'] = zbx_dbstr($graph['percent_right']);
+		if(isset($graph['templateid'])) $values['templateid'] = zbx_dbstr($graph['templateid']);
 
 		$sql = 'INSERT INTO graphs ('.implode(', ', array_keys($values)).') VALUES ('.implode(', ', $values).')';
 		if(!DBexecute($sql))
@@ -745,14 +745,14 @@
 				'gitemid' => get_dbid('graphs_items', 'gitemid'),
 				'graphid' => $graphid,
 			);
-			if(isset($gitem['itemid'])) $values['itemid'] = $gitem['itemid'];
+			if(isset($gitem['itemid'])) $values['itemid'] = zbx_dbstr($gitem['itemid']);
 			if(isset($gitem['color'])) $values['color'] = zbx_dbstr($gitem['color']);
-			if(isset($gitem['drawtype'])) $values['drawtype'] = $gitem['drawtype'];
-			if(isset($gitem['sortorder'])) $values['sortorder'] = $gitem['sortorder'];
-			if(isset($gitem['yaxisside'])) $values['yaxisside'] = $gitem['yaxisside'];
-			if(isset($gitem['calc_fnc'])) $values['calc_fnc'] = $gitem['calc_fnc'];
-			if(isset($gitem['type'])) $values['type'] = $gitem['type'];
-			if(isset($gitem['periods_cnt'])) $values['periods_cnt'] = $gitem['periods_cnt'];
+			if(isset($gitem['drawtype'])) $values['drawtype'] = zbx_dbstr($gitem['drawtype']);
+			if(isset($gitem['sortorder'])) $values['sortorder'] = zbx_dbstr($gitem['sortorder']);
+			if(isset($gitem['yaxisside'])) $values['yaxisside'] = zbx_dbstr($gitem['yaxisside']);
+			if(isset($gitem['calc_fnc'])) $values['calc_fnc'] = zbx_dbstr($gitem['calc_fnc']);
+			if(isset($gitem['type'])) $values['type'] = zbx_dbstr($gitem['type']);
+			if(isset($gitem['periods_cnt'])) $values['periods_cnt'] = zbx_dbstr($gitem['periods_cnt']);
 
 			$sql = 'INSERT INTO graphs_items ('.implode(', ', array_keys($values)).') VALUES ('.implode(', ', $values).')';
 			DBexecute($sql) or self::exception(ZBX_API_ERROR_PARAMETERS, 'DBerror');
@@ -768,7 +768,7 @@
 
 
 		if(isset($graph['gitems'])){
-			if(!DBexecute('DELETE FROM graphs_items WHERE graphid='.$graph['graphid']))
+			if(!DBexecute('DELETE FROM graphs_items WHERE graphid='.zbx_dbstr($graph['graphid'])))
 				self::exception(ZBX_API_ERROR_PARAMETERS, 'DBerror');
 
 			foreach($graph['gitems'] as $inum => $gitem){
Index: frontends/php/api/classes/class.capplication.php
===================================================================
--- frontends/php/api/classes/class.capplication.php	(revision 38884)
+++ frontends/php/api/classes/class.capplication.php	(working copy)
@@ -645,7 +645,7 @@
 			DB::insert('items_applications', $apps_insert);
 
 			foreach($itemids as $inum => $itemid){
-				$db_childs = DBselect('SELECT itemid, hostid FROM items WHERE templateid=' . $itemid);
+				$db_childs = DBselect('SELECT itemid, hostid FROM items WHERE templateid='.zbx_dbstr($itemid));
 
 				while($child = DBfetch($db_childs)){
 					$sql = 'SELECT a1.applicationid ' .
Index: frontends/php/api/classes/class.cscript.php
===================================================================
--- frontends/php/api/classes/class.cscript.php	(revision 38884)
+++ frontends/php/api/classes/class.cscript.php	(working copy)
@@ -343,7 +343,7 @@
 		$sql = 'SELECT scriptid '.
 				' FROM scripts '.
 				' WHERE '.DBin_node('scriptid').
-					' AND name='.$script['name'];
+					' AND name='.zbx_dbstr($script['name']);
 		$res = DBselect($sql);
 		while($script = DBfetch($res)){
 			$scriptids[$script['scriptid']] = $script['scriptid'];
Index: frontends/php/api/classes/class.calert.php
===================================================================
--- frontends/php/api/classes/class.calert.php	(revision 38884)
+++ frontends/php/api/classes/class.calert.php	(working copy)
@@ -282,12 +282,12 @@
 
 // time_from
 		if(!is_null($options['time_from'])){
-			$sql_parts['where'][] = 'a.clock>'.$options['time_from'];
+			$sql_parts['where'][] = 'a.clock>'.zbx_dbstr($options['time_from']);
 		}
 
 // time_till
 		if(!is_null($options['time_till'])){
-			$sql_parts['where'][] = 'a.clock<'.$options['time_till'];
+			$sql_parts['where'][] = 'a.clock<'.zbx_dbstr($options['time_till']);
 		}
 
 // extendoutput
@@ -511,10 +511,10 @@
 			$alertid = get_dbid('alerts', 'alertid');
 			$sql = 'INSERT INTO alerts '.
 					'(alertid, actionid, eventid, userid, mediatypeid, clock, sendto, subject, message, status, retries, error, nextcheck, esc_step, alerttype) '.
-					' VALUES ('.$alertid.','.$alert['actionid'].','.$alert['eventid'].','.$alert['userid'].','.$alert['mediatypeid'].','.
-								$alert['clock'].','.zbx_dbstr($alert['sendto']).','.zbx_dbstr($alert['subject']).','.zbx_dbstr($alert['message']).','.
-								$alert['status'].','.$alert['retries'].','.zbx_dbstr($alert['error']).','.$alert['nextcheck'].','.
-								$alert['esc_step'].','.$alert['alerttype'].' )';
+					' VALUES ('.$alertid.','.zbx_dbstr($alert['actionid']).','.zbx_dbstr($alert['eventid']).','.zbx_dbstr($alert['userid']).','.zbx_dbstr($alert['mediatypeid']).','.
+								zbx_dbstr($alert['clock']).','.zbx_dbstr($alert['sendto']).','.zbx_dbstr($alert['subject']).','.zbx_dbstr($alert['message']).','.
+								zbx_dbstr($alert['status']).','.zbx_dbstr($alert['retries']).','.zbx_dbstr($alert['error']).','.zbx_dbstr($alert['nextcheck']).','.
+								zbx_dbstr($alert['esc_step']).','.zbx_dbstr($alert['alerttype']).' )';
 			$result = DBexecute($sql);
 			if(!$result) break;
 
Index: frontends/php/api/classes/class.ctemplate.php
===================================================================
--- frontends/php/api/classes/class.ctemplate.php	(revision 38884)
+++ frontends/php/api/classes/class.ctemplate.php	(working copy)
@@ -998,7 +998,7 @@
 
 				foreach($template['groups'] as $group){
 					$hostgroupid = get_dbid('hosts_groups', 'hostgroupid');
-					$result = DBexecute("INSERT INTO hosts_groups (hostgroupid, hostid, groupid) VALUES ($hostgroupid, $templateid, {$group['groupid']})");
+					$result = DBexecute('INSERT INTO hosts_groups (hostgroupid, hostid, groupid) VALUES ('.$hostgroupid.','.zbx_dbstr($templateid).','.zbx_dbstr($group['groupid']).')');
 					if(!$result){
 						self::exception(ZBX_API_ERROR_PARAMETERS, 'DBerror');
 					}
@@ -1633,7 +1633,7 @@
 					if(isset($link[$targetid]) && ($link[$targetid] == $templateid)) continue 2;
 				}
 
-				$values = array(get_dbid('hosts_templates', 'hosttemplateid'), $targetid, $templateid);
+				$values = array(get_dbid('hosts_templates', 'hosttemplateid'), zbx_dbstr($targetid), zbx_dbstr($templateid));
 				$sql = 'INSERT INTO hosts_templates VALUES ('. implode(', ', $values) .')';
 				$result = DBexecute($sql);
 
Index: frontends/php/api/classes/class.cdrule.php
===================================================================
--- frontends/php/api/classes/class.cdrule.php	(revision 38884)
+++ frontends/php/api/classes/class.cdrule.php	(working copy)
@@ -588,7 +588,7 @@
 		if($host["status"] == HOST_STATUS_TEMPLATE ){
 			$sql = 'SELECT DISTINCT count(i.hostid) as count
 					FROM checks i
-					WHERE i.hostid<>'.$host['hostid'].
+					WHERE i.hostid<>'.zbx_dbstr($host['hostid']).
 						' AND '.DBcondition('i.checkid', $checkids);
 
 			$host_count = DBfetch(DBselect($sql));
@@ -641,7 +641,7 @@
 
 		$sql = 'SELECT curr.checkid
 				FROM drules_checks gi, checks curr, checks src
-				WHERE gi.druleid='.$druleid.
+				WHERE gi.druleid='.zbx_dbstr($druleid).
 					' AND gi.checkid=curr.checkid
 					AND curr.key_=src.key_
 					AND '.DBcondition('src.checkid', $checks);
@@ -653,7 +653,7 @@
 
 		$sql = 'DELETE
 				FROM drules_checks
-				WHERE druleid='.$druleid.
+				WHERE druleid='.zbx_dbstr($druleid).
 					' AND '.DBcondition('checkid', $gchecks);
 		$result = DBselect($sql);
 
Index: frontends/php/api/classes/class.cmap.php
===================================================================
--- frontends/php/api/classes/class.cmap.php	(revision 38884)
+++ frontends/php/api/classes/class.cmap.php	(working copy)
@@ -674,13 +674,13 @@
 //----
 			$sql = 'UPDATE sysmaps '.
 					' SET name='.zbx_dbstr($map['name']).','.
-						' width='.$map['width'].','.
-						' height='.$map['height'].','.
-						' backgroundid='.$map['backgroundid'].','.
-						' highlight='.$map['highlight'].','.
-						' label_type='.$map['label_type'].','.
-						' label_location='.$map['label_location'].
-					' WHERE sysmapid='.$map['sysmapid'];
+						' width='.zbx_dbstr($map['width']).','.
+						' height='.zbx_dbstr($map['height']).','.
+						' backgroundid='.zbx_dbstr($map['backgroundid']).','.
+						' highlight='.zbx_dbstr($map['highlight']).','.
+						' label_type='.zbx_dbstr($map['label_type']).','.
+						' label_location='.zbx_dbstr($map['label_location']).
+					' WHERE sysmapid='.zbx_dbstr($map['sysmapid']);
 			$result = DBexecute($sql);
 
 			if(!$result) break;
@@ -901,18 +901,18 @@
 
 				$values = array(
 					'selementid' => $selementid,
-					'sysmapid' => $selement['sysmapid'],
-					'elementid' => $selement['elementid'],
-					'elementtype' => $selement['elementtype'],
+					'sysmapid' => zbx_dbstr($selement['sysmapid']),
+					'elementid' => zbx_dbstr($selement['elementid']),
+					'elementtype' => zbx_dbstr($selement['elementtype']),
 					'label' => zbx_dbstr($selement['label']),
-					'label_location' => $selement['label_location'],
-					'iconid_off' => $selement['iconid_off'],
-					'iconid_on' => $selement['iconid_on'],
-					'iconid_unknown' => $selement['iconid_unknown'],
-					'iconid_maintenance' => $selement['iconid_maintenance'],
-					'iconid_disabled' => $selement['iconid_disabled'],
-					'x' => $selement['x'],
-					'y' => $selement['y'],
+					'label_location' => zbx_dbstr($selement['label_location']),
+					'iconid_off' => zbx_dbstr($selement['iconid_off']),
+					'iconid_on' => zbx_dbstr($selement['iconid_on']),
+					'iconid_unknown' => zbx_dbstr($selement['iconid_unknown']),
+					'iconid_maintenance' => zbx_dbstr($selement['iconid_maintenance']),
+					'iconid_disabled' => zbx_dbstr($selement['iconid_disabled']),
+					'x' => zbx_dbstr($selement['x']),
+					'y' => zbx_dbstr($selement['y']),
 					'url' => zbx_dbstr($selement['url'])
 				);
 
@@ -1006,19 +1006,19 @@
 				}
 
 				$result = DBexecute('UPDATE sysmaps_elements '.
-						'SET elementid='.$selement['elementid'].', '.
-							' elementtype='.$selement['elementtype'].', '.
+						'SET elementid='.zbx_dbstr($selement['elementid']).', '.
+							' elementtype='.zbx_dbstr($selement['elementtype']).', '.
 							' label='.zbx_dbstr($selement['label']).', '.
-							' label_location='.$selement['label_location'].', '.
-							' x='.$selement['x'].', '.
-							' y='.$selement['y'].', '.
-							' iconid_off='.$selement['iconid_off'].', '.
-							' iconid_on='.$selement['iconid_on'].', '.
-							' iconid_unknown='.$selement['iconid_unknown'].', '.
-							' iconid_maintenance='.$selement['iconid_maintenance'].', '.
-							' iconid_disabled='.$selement['iconid_disabled'].', '.
+							' label_location='.zbx_dbstr($selement['label_location']).', '.
+							' x='.zbx_dbstr($selement['x']).', '.
+							' y='.zbx_dbstr($selement['y']).', '.
+							' iconid_off='.zbx_dbstr($selement['iconid_off']).', '.
+							' iconid_on='.zbx_dbstr($selement['iconid_on']).', '.
+							' iconid_unknown='.zbx_dbstr($selement['iconid_unknown']).', '.
+							' iconid_maintenance='.zbx_dbstr($selement['iconid_maintenance']).', '.
+							' iconid_disabled='.zbx_dbstr($selement['iconid_disabled']).', '.
 							' url='.zbx_dbstr($selement['url']).
-						' WHERE selementid='.$selement['selementid']);
+						' WHERE selementid='.zbx_dbstr($selement['selementid']));
 
 				if(!$result) self::exception(ZBX_API_ERROR_INTERNAL, 'Map update elements failed');
 
@@ -1120,8 +1120,8 @@
 
 			$linktriggerid = get_dbid('sysmaps_link_triggers', 'linktriggerid');
 			$sql = 'INSERT INTO sysmaps_link_triggers (linktriggerid, linkid, triggerid, drawtype, color) '.
-				' VALUES ('.$linktriggerid.','.$linktrigger['linkid'].','.$linktrigger['triggerid'].', '.
-					$linktrigger['drawtype'].','.zbx_dbstr($linktrigger['color']).')';
+				' VALUES ('.$linktriggerid.','.zbx_dbstr($linktrigger['linkid']).','.zbx_dbstr($linktrigger['triggerid']).', '.
+					zbx_dbstr($linktrigger['drawtype']).','.zbx_dbstr($linktrigger['color']).')';
 			$result = DBexecute($sql);
 			if(!$result){
 				$result = false;
Index: frontends/php/api/classes/class.cuser.php
===================================================================
--- frontends/php/api/classes/class.cuser.php	(revision 38884)
+++ frontends/php/api/classes/class.cuser.php	(working copy)
@@ -463,13 +463,13 @@
 					zbx_dbstr($user['alias']).','.
 					zbx_dbstr(md5($user['passwd'])).','.
 					zbx_dbstr($user['url']).','.
-					$user['autologin'].','.
-					$user['autologout'].','.
+					zbx_dbstr($user['autologin']).','.
+					zbx_dbstr($user['autologout']).','.
 					zbx_dbstr($user['lang']).','.
 					zbx_dbstr($user['theme']).','.
-					$user['refresh'].','.
-					$user['rows_per_page'].','.
-					$user['type'].
+					zbx_dbstr($user['refresh']).','.
+					zbx_dbstr($user['rows_per_page']).','.
+					zbx_dbstr($user['type']).
 				')');
 
 			if($result){
@@ -478,7 +478,7 @@
 					if(!$result) break;
 					$users_groups_id = get_dbid("users_groups","id");
 					$result = DBexecute('INSERT INTO users_groups (id,usrgrpid,userid)'.
-						'values('.$users_groups_id.','.$groupid.','.$userid.')');
+						'values('.$users_groups_id.','.zbx_dbstr($groupid).','.zbx_dbstr($userid).')');
 				}
 			}
 
@@ -487,8 +487,8 @@
 					if(!$result) break;
 					$mediaid = get_dbid('media', 'mediaid');
 					$result = DBexecute('INSERT INTO media (mediaid,userid,mediatypeid,sendto,active,severity,period)'.
-						' VALUES ('.$mediaid.','.$userid.','.$media_data['mediatypeid'].','.
-						zbx_dbstr($media_data['sendto']).','.$media_data['active'].','.$media_data['severity'].','.
+						' VALUES ('.$mediaid.','.zbx_dbstr($userid).','.zbx_dbstr($media_data['mediatypeid']).','.
+						zbx_dbstr($media_data['sendto']).','.zbx_dbstr($media_data['active']).','.zbx_dbstr($media_data['severity']).','.
 						zbx_dbstr($media_data['period']).')');
 				}
 			}
@@ -613,14 +613,14 @@
 						' alias='.zbx_dbstr($user['alias']).', '.
 						' passwd='.zbx_dbstr($user['passwd']).', '.
 						' url='.zbx_dbstr($user['url']).', '.
-						' autologin='.$user['autologin'].', '.
-						' autologout='.$user['autologout'].', '.
+						' autologin='.zbx_dbstr($user['autologin']).', '.
+						' autologout='.zbx_dbstr($user['autologout']).', '.
 						' lang='.zbx_dbstr($user['lang']).', '.
 						' theme='.zbx_dbstr($user['theme']).', '.
-						' refresh='.$user['refresh'].', '.
-						' rows_per_page='.$user['rows_per_page'].', '.
-						' type='.$user['type'].
-					' WHERE userid='.$user['userid'];
+						' refresh='.zbx_dbstr($user['refresh']).', '.
+						' rows_per_page='.zbx_dbstr($user['rows_per_page']).', '.
+						' type='.zbx_dbstr($user['type']).
+					' WHERE userid='.zbx_dbstr($user['userid']);
 
 			$result = DBexecute($sql);
 
@@ -644,7 +644,7 @@
 
 
 			if($result && isset($user['usrgrps']) && !is_null($user['usrgrps'])){
-				DBexecute('DELETE FROM users_groups WHERE userid='.$user['userid']);
+				DBexecute('DELETE FROM users_groups WHERE userid='.zbx_dbstr($user['userid']));
 
 				$options = array(
 					'usrgrpids' => zbx_objectValues($user['usrgrps'], 'usrgrpid'),
@@ -669,7 +669,7 @@
 					}
 
 					$users_groups_id = get_dbid('users_groups', 'id');
-					$result = DBexecute('INSERT INTO users_groups (id, usrgrpid, userid) VALUES ('.$users_groups_id.','.$groupid.','.$user['userid'].')');
+					$result = DBexecute('INSERT INTO users_groups (id, usrgrpid, userid) VALUES ('.$users_groups_id.','.zbx_dbstr($groupid).','.zbx_dbstr($user['userid']).')');
 				}
 			}
 /*
@@ -771,13 +771,13 @@
 		$sql = 'UPDATE users SET '.
 					' passwd='.zbx_dbstr($user['passwd']).', '.
 					' url='.zbx_dbstr($user['url']).', '.
-					' autologin='.$user['autologin'].', '.
-					' autologout='.$user['autologout'].', '.
+					' autologin='.zbx_dbstr($user['autologin']).', '.
+					' autologout='.zbx_dbstr($user['autologout']).', '.
 					' lang='.zbx_dbstr($user['lang']).', '.
 					' theme='.zbx_dbstr($user['theme']).', '.
-					' refresh='.$user['refresh'].', '.
-					' rows_per_page='.$user['rows_per_page'].
-				' WHERE userid='.$user['userid'];
+					' refresh='.zbx_dbstr($user['refresh']).', '.
+					' rows_per_page='.zbx_dbstr($user['rows_per_page']).
+				' WHERE userid='.zbx_dbstr($user['userid']);
 
 		$result = DBexecute($sql);
 
@@ -912,8 +912,8 @@
 				$mediaid = get_dbid('media','mediaid');
 
 				$sql='INSERT INTO media (mediaid,userid,mediatypeid,sendto,active,severity,period) '.
-						' VALUES ('.$mediaid.','.$user['userid'].','.$media['mediatypeid'].','.
-									zbx_dbstr($media['sendto']).','.$media['active'].','.$media['severity'].','.
+						' VALUES ('.$mediaid.','.zbx_dbstr($user['userid']).','.zbx_dbstr($media['mediatypeid']).','.
+									zbx_dbstr($media['sendto']).','.zbx_dbstr($media['active']).','.zbx_dbstr($media['severity']).','.
 									zbx_dbstr($media['period']).')';
 
 				$result = DBexecute($sql);
@@ -1039,12 +1039,12 @@
 				}
 
 				$sql = 'UPDATE media '.
-						' SET mediatypeid='.$media['mediatypeid'].','.
+						' SET mediatypeid='.zbx_dbstr($media['mediatypeid']).','.
 							' sendto='.zbx_dbstr($media['sendto']).','.
-							' active='.$media['active'].','.
-							' severity='.$media['severity'].','.
+							' active='.zbx_dbstr($media['active']).','.
+							' severity='.zbx_dbstr($media['severity']).','.
 							' period='.zbx_dbstr($media['period']).
-						' WHERE mediaid='.$media['mediaid'];
+						' WHERE mediaid='.zbx_dbstr($media['mediaid']);
 				$result = DBexecute($sql);
 				if(!$result){
 					throw new APIException(ZBX_API_ERROR_PARAMETERS, S_CUSER_ERROR_CANT_UPDATE_USER_MEDIAS);
@@ -1255,7 +1255,7 @@
 							' SET attempt_failed='.$attempt['attempt_failed'].','.
 								' attempt_clock='.time().','.
 								' attempt_ip='.zbx_dbstr($ip).
-							' WHERE userid='.$attempt['userid'];
+							' WHERE userid='.zbx_dbstr($attempt['userid']);
 					DBexecute($sql);
 				}
 			}
Index: frontends/php/api/classes/class.cevent.php
===================================================================
--- frontends/php/api/classes/class.cevent.php	(revision 38884)
+++ frontends/php/api/classes/class.cevent.php	(working copy)
@@ -239,12 +239,12 @@
 
 // object
 		if(!is_null($options['object'])){
-			$sql_parts['where']['o'] = 'e.object='.$options['object'];
+			$sql_parts['where']['o'] = 'e.object='.zbx_dbstr($options['object']);
 		}
 
 // source
 		if(!is_null($options['source'])){
-			$sql_parts['where'][] = 'e.source='.$options['source'];
+			$sql_parts['where'][] = 'e.source='.zbx_dbstr($options['source']);
 		}
 // acknowledged
 		if(!is_null($options['acknowledged'])){
@@ -256,19 +256,19 @@
 		}
 // time_from
 		if(!is_null($options['time_from'])){
-			$sql_parts['where'][] = 'e.clock>='.$options['time_from'];
+			$sql_parts['where'][] = 'e.clock>='.zbx_dbstr($options['time_from']);
 		}
 // time_till
 		if(!is_null($options['time_till'])){
-			$sql_parts['where'][] = 'e.clock<='.$options['time_till'];
+			$sql_parts['where'][] = 'e.clock<='.zbx_dbstr($options['time_till']);
 		}
 // eventid_from
 		if(!is_null($options['eventid_from'])){
-			$sql_parts['where'][] = 'e.eventid>='.$options['eventid_from'];
+			$sql_parts['where'][] = 'e.eventid>='.zbx_dbstr($options['eventid_from']);
 		}
 // eventid_till
 		if(!is_null($options['eventid_till'])){
-			$sql_parts['where'][] = 'e.eventid<='.$options['eventid_till'];
+			$sql_parts['where'][] = 'e.eventid<='.zbx_dbstr($options['eventid_till']);
 		}
 // value
 		if(!is_null($options['value'])){
@@ -575,12 +575,12 @@
 			$eventid = get_dbid('events','eventid');
 			$sql = 'INSERT INTO events (eventid, source, object, objectid, clock, value, acknowledged) '.
 					' VALUES ('.$eventid.','.
-								$event['source'].','.
-								$event['object'].','.
-								$event['objectid'].','.
-								$event['clock'].','.
-								$event['value'].','.
-								$event['acknowledged'].
+								zbx_dbstr($event['source']).','.
+								zbx_dbstr($event['object']).','.
+								zbx_dbstr($event['objectid']).','.
+								zbx_dbstr($event['clock']).','.
+								zbx_dbstr($event['value']).','.
+								zbx_dbstr($event['acknowledged']).
 							')';
 			$result = DBexecute($sql);
 			if(!$result) break;
@@ -716,26 +716,26 @@
 					' WHERE e.object='.EVENT_OBJECT_TRIGGER.
 						' AND e.objectid='.$event['objectid'].
 						' AND e.value='.$val.
-						' AND e.eventid<'.$event['eventid'].
+						' AND e.eventid<'.zbx_dbstr($event['eventid']).
 					' ORDER BY e.object DESC,e.objectid DESC,e.eventid DESC';
 				$first = DBfetch(DBselect($sql, 1));
-				$first_sql = $first ? ' AND e.eventid>'.$first['eventid'] : '';
+				$first_sql = $first ? ' AND e.eventid>'.zbx_dbstr($first['eventid']) : '';
 
 				$sql = 'SELECT e.object,e.objectid,e.eventid'.
 					' FROM events e'.
 					' WHERE e.object='.EVENT_OBJECT_TRIGGER.
-						' AND e.objectid='.$event['objectid'].
-						' AND e.value='.$val.
-						' AND e.eventid>'.$event['eventid'].
+						' AND e.objectid='.zbx_dbstr($event['objectid']).
+						' AND e.value='.zbx_dbstr($val).
+						' AND e.eventid>'.zbx_dbstr($event['eventid']).
 					' ORDER BY e.object,e.objectid,e.eventid';
 				$last = DBfetch(DBselect($sql, 1));
-				$last_sql = $last ? ' AND e.eventid<'.$last['eventid'] : '';
+				$last_sql = $last ? ' AND e.eventid<'.zbx_dbstr($last['eventid']) : '';
 
 				$sql = 'SELECT e.eventid'.
 					' FROM events e'.
 					' WHERE e.object='.EVENT_OBJECT_TRIGGER.
-						' AND e.objectid='.$event['objectid'].
-						' AND e.value='.$event['value'].
+						' AND e.objectid='.zbx_dbstr($event['objectid']).
+						' AND e.value='.zbx_dbstr($event['value']).
 						$first_sql.
 						$last_sql;
 
Index: frontends/php/api/classes/class.chostgroup.php
===================================================================
--- frontends/php/api/classes/class.chostgroup.php	(revision 38884)
+++ frontends/php/api/classes/class.chostgroup.php	(working copy)
@@ -697,7 +697,7 @@
 				$groupsNames[$group['name']] = array('groupid' => $group['groupid']);
 //---
 
-				$sql = 'UPDATE groups SET name='.zbx_dbstr($group['name']).' WHERE groupid='.$group['groupid'];
+				$sql = 'UPDATE groups SET name='.zbx_dbstr($group['name']).' WHERE groupid='.zbx_dbstr($group['groupid']);
 				if(!DBexecute($sql)){
 					self::exception(ZBX_API_ERROR_PARAMETERS, 'DBerror');
 				}
@@ -812,7 +812,7 @@
 				foreach($objectids as $hostid){
 					if(isset($linked[$groupid][$hostid])) continue;
 					$hostgroupid = get_dbid('hosts_groups', 'hostgroupid');
-					$result = DBexecute("INSERT INTO hosts_groups (hostgroupid, hostid, groupid) VALUES ($hostgroupid, $hostid, $groupid)");
+					$result = DBexecute('INSERT INTO hosts_groups (hostgroupid, hostid, groupid) VALUES ('.zbx_dbstr($hostgroupid).','.zbx_dbstr($hostid).','.zbx_dbstr($groupid).')');
 					if(!$result){
 						self::exception(ZBX_API_ERROR_PARAMETERS, 'DBerror');
 					}
@@ -984,7 +984,7 @@
 			foreach($groupids as $gnum => $groupid){
 				foreach($objectids_to_link as $objectid){
 					$hostgroupid = get_dbid('hosts_groups', 'hostgroupid');
-					$result = DBexecute("INSERT INTO hosts_groups (hostgroupid, hostid, groupid) VALUES ($hostgroupid, $objectid, $groupid)");
+					$result = DBexecute('INSERT INTO hosts_groups (hostgroupid, hostid, groupid) VALUES ('.zbx_dbstr($hostgroupid).','.zbx_dbstr($objectid).','.zbx_dbstr($groupid).')');
 					if(!$result){
 						self::exception(ZBX_API_ERROR_PARAMETERS, 'DBerror');
 					}
Index: frontends/php/api/classes/class.cusergroup.php
===================================================================
--- frontends/php/api/classes/class.cusergroup.php	(revision 38884)
+++ frontends/php/api/classes/class.cusergroup.php	(working copy)
@@ -147,7 +147,7 @@
 
 // status
 		if(!is_null($options['status'])){
-			$sql_parts['where'][] = 'g.users_status='.$options['status'];
+			$sql_parts['where'][] = 'g.users_status='.zbx_dbstr($options['status']);
 		}
 
 // with_gui_access
Index: frontends/php/api/classes/class.chistory.php
===================================================================
--- frontends/php/api/classes/class.chistory.php	(revision 38884)
+++ frontends/php/api/classes/class.chistory.php	(working copy)
@@ -172,13 +172,13 @@
 // time_from
 		if(!is_null($options['time_from'])){
 			$sql_parts['select']['clock'] = 'h.clock';
-			$sql_parts['where']['clock_from'] = 'h.clock>='.$options['time_from'];
+			$sql_parts['where']['clock_from'] = 'h.clock>='.zbx_dbstr($options['time_from']);
 		}
 
 // time_till
 		if(!is_null($options['time_till'])){
 			$sql_parts['select']['clock'] = 'h.clock';
-			$sql_parts['where']['clock_till'] = 'h.clock<='.$options['time_till'];
+			$sql_parts['where']['clock_till'] = 'h.clock<='.zbx_dbstr($options['time_till']);
 		}
 
 // filter
Index: frontends/php/api/classes/class.ctrigger.php
===================================================================
--- frontends/php/api/classes/class.ctrigger.php	(revision 38884)
+++ frontends/php/api/classes/class.ctrigger.php	(working copy)
@@ -384,12 +384,12 @@
 
 // lastChangeSince
 		if(!is_null($options['lastChangeSince'])){
-			$sql_parts['where']['lastchangesince'] = 't.lastchange>'.$options['lastChangeSince'];
+			$sql_parts['where']['lastchangesince'] = 't.lastchange>'.zbx_dbstr($options['lastChangeSince']);
 		}
 
 // lastChangeTill
 		if(!is_null($options['lastChangeTill'])){
-			$sql_parts['where']['lastchangetill'] = 't.lastchange<'.$options['lastChangeTill'];
+			$sql_parts['where']['lastchangetill'] = 't.lastchange<'.zbx_dbstr($options['lastChangeTill']);
 		}
 
 // withUnacknowledgedEvents
@@ -517,7 +517,7 @@
 
 // min_severity
 		if(!is_null($options['min_severity'])){
-			$sql_parts['where'][] = 't.priority>='.$options['min_severity'];
+			$sql_parts['where'][] = 't.priority>='.zbx_dbstr($options['min_severity']);
 		}
 
 // output
